///////////////////////////////////////////
//
// file:  DIV.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void DIV( )
{
   int           abs_areg = 0;
   int           previous_sign_of_areg = 0;
   int           quotient = 0;
   int           remainder = 0;
   int           v = 0;

   long long int reg = 0;
   long long int reg_buffer = 0;

   MIX_word      V = GETV( );

   abs_areg = (AREG.Byte_1( ) << 24)
              | (AREG.Byte_2( ) << 18)
              | (AREG.Byte_3( ) << 12)
              | (AREG.Byte_4( ) << 6)
              | AREG.Byte_5( );

   reg_buffer = AREG.Byte_1( );
   reg = (reg_buffer << 54);
   reg_buffer = AREG.Byte_2( );
   reg |= (reg_buffer << 48);
   reg_buffer = AREG.Byte_3( );
   reg |= (reg_buffer << 42);
   reg_buffer = AREG.Byte_4( );
   reg |= (reg_buffer << 36);
   reg_buffer = AREG.Byte_5( );
   reg |= (reg_buffer << 30);
   reg_buffer = XREG.Byte_1( );
   reg |= (reg_buffer << 24);
   reg_buffer = XREG.Byte_2( );
   reg |= (reg_buffer << 18);
   reg_buffer = XREG.Byte_3( );
   reg |= (reg_buffer << 12);
   reg_buffer = XREG.Byte_4( );
   reg |= (reg_buffer << 6);
   reg_buffer = XREG.Byte_5( );
   reg |= reg_buffer;

   if( (previous_sign_of_areg = AREG.Byte_0( )) )
      reg = -reg;

   v = (V.Byte_1( ) << 24)
       + (V.Byte_2( ) << 18)
       + (V.Byte_3( ) << 12)
       + (V.Byte_4( ) << 6)
       + V.Byte_5( );

   if( V.Byte_0( ) )
      v = -v;

   if( abs_areg >= abs( v ) )
   {
      quotient = 0x3FFFFFF;
      remainder = 0x3FFFFFF;
      OVTOG.Byte_5( 1 );
   }
   else
   {
      quotient = reg / v;
      remainder = reg % v;
   }

   if( quotient < 0 )
   {
      AREG.Byte_0( 1 );
      quotient = -quotient;
   }
   else
      AREG.Byte_0( 0 );

   AREG.Byte_1( (quotient >> 24) & 0x3F );
   AREG.Byte_2( (quotient >> 18) & 0x3F );
   AREG.Byte_3( (quotient >> 12) & 0x3F );
   AREG.Byte_4( (quotient >> 6) & 0x3F );
   AREG.Byte_5( quotient & 0x3F );

   XREG.Byte_0( previous_sign_of_areg );
   XREG.Byte_1( (remainder >> 24) & 0x3F );
   XREG.Byte_2( (remainder >> 18) & 0x3F );
   XREG.Byte_3( (remainder >> 12) & 0x3F );
   XREG.Byte_4( (remainder >> 6) & 0x3F );
   XREG.Byte_5( remainder  & 0x3F );

   u_counter += 12;
}
