///////////////////////////////////////////
//
// file:  JBIT.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void JBIT( )
{
   bool N = false;
   bool P = false;
   bool Z = false;

   int  f = INST.F( );
   int  opcode = INST.C( );

   switch( opcode )
   {
      case 40:
         N = AREG.Byte_0( );
         Z = !(AREG.Byte_1( )
               || AREG.Byte_2( )
               || AREG.Byte_3( )
               || AREG.Byte_4( )
               || AREG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 41:
         N = I1REG.Byte_0( );
         Z = !(I1REG.Byte_4( )
               || I1REG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 42:
         N = I2REG.Byte_0( );
         Z = !(I2REG.Byte_4( )
               || I2REG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 43:
         N = I3REG.Byte_0( );
         Z = !(I3REG.Byte_4( )
               || I3REG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 44:
         N = I4REG.Byte_0( );
         Z = !(I4REG.Byte_4( )
               || I4REG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 45:
         N = I5REG.Byte_0( );
         Z = !(I5REG.Byte_4( )
               || I5REG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 46:
         N = I6REG.Byte_0( );
         Z = !(I6REG.Byte_4( )
               || I6REG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

      case 47:
         N = XREG.Byte_0( );
         Z = !(XREG.Byte_1( )
               || XREG.Byte_2( )
               || XREG.Byte_3( )
               || XREG.Byte_4( )
               || XREG.Byte_5( ) );

         P = !N && !Z;

         switch( f )
         {
            case 0:
               if( N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 1:
               if( Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 2:
               if( P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 3:
               if( !N )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 4:
               if( !Z )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            case 5:
               if( !P )
               {
                  JREG.Byte_4( (program_counter >> 6) & 0x3F );
                  JREG.Byte_5( program_counter & 0x3F );

                  program_counter = INST.M( );
               }
               break;

            default:
               break;
         }
         break;

   }

   u_counter++;
}
