///////////////////////////////////////////
//
// file:  init_f_settings.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIXAL. 
//
//    MIXAL is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIXAL is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIXAL; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void init_f_settings( map< string, int >& f_settings )
{
   f_settings["NOP"] = 0;
   f_settings["ADD"] = 5;
   f_settings["SUB"] = 5;
   f_settings["MUL"] = 5;
   f_settings["DIV"] = 5;
   f_settings["NUM"] = 0;
   f_settings["CHAR"] = 1;
   f_settings["HLT"] = 2;
   f_settings["ENB"] = 3;
   f_settings["DIS"] = 4;
   f_settings["INT"] = 7;
   f_settings["SLA"] = 0;
   f_settings["SRA"] = 1;
   f_settings["SLAX"] = 1;
   f_settings["SRAX"] = 3;
   f_settings["SLC"] = 4;
   f_settings["SRC"] = 5;
   f_settings["MOVE"] = 1;
   f_settings["LDA" ] = 5;
   f_settings["LD1" ] = 5;
   f_settings["LD2" ] = 5;
   f_settings["LD3" ] = 5;
   f_settings["LD4" ] = 5;
   f_settings["LD5" ] = 5;
   f_settings["LD6" ] = 5;
   f_settings["LDX" ] = 5;
   f_settings["LDAN" ] = 5;
   f_settings["LD1N" ] = 5;
   f_settings["LD2N" ] = 5;
   f_settings["LD3N" ] = 5;
   f_settings["LD4N" ] = 5;
   f_settings["LD5N" ] = 5;
   f_settings["LD6N" ] = 5;
   f_settings["LDXN" ] = 5;
   f_settings["STA"] = 5;
   f_settings["ST1"] = 5;
   f_settings["ST2"] = 5;
   f_settings["ST3"] = 5;
   f_settings["ST4"] = 5;
   f_settings["ST5"] = 5;
   f_settings["ST6"] = 5;
   f_settings["STX"] = 5;
   f_settings["STJ"] = 2;
   f_settings["STZ"] = 5;
   f_settings["JBUS"] = 0;
   f_settings["IOC"] = 0;
   f_settings["IN"] = 0;
   f_settings["OUT"] = 0;
   f_settings["JRED"] = 0;
   f_settings["JMP"] = 0;
   f_settings["JSJ"] = 1;
   f_settings["JOV"] = 2;
   f_settings["JNOV"] = 3;
   f_settings["JL"] = 4;
   f_settings["JE"] = 5;
   f_settings["JG"] = 6;
   f_settings["JGE"] = 7;
   f_settings["JNE"] = 8;
   f_settings["JLE"] = 9;
   f_settings["JAN"] = 0;
   f_settings["J1N"] = 0;
   f_settings["J2N"] = 0;
   f_settings["J3N"] = 0;
   f_settings["J4N"] = 0;
   f_settings["J5N"] = 0;
   f_settings["J6N"] = 0;
   f_settings["JXN"] = 0;
   f_settings["JAZ"] = 1;
   f_settings["J1Z"] = 1;
   f_settings["J2Z"] = 1;
   f_settings["J3Z"] = 1;
   f_settings["J4Z"] = 1;
   f_settings["J5Z"] = 1;
   f_settings["J6Z"] = 1;
   f_settings["JXZ"] = 1;
   f_settings["JAP"] = 2;
   f_settings["J1P"] = 2;
   f_settings["J2P"] = 2;
   f_settings["J3P"] = 2;
   f_settings["J4P"] = 2;
   f_settings["J5P"] = 2;
   f_settings["J6P"] = 2;
   f_settings["JXP"] = 2;
   f_settings["JANN"] = 0;
   f_settings["J1NN"] = 0;
   f_settings["J2NN"] = 0;
   f_settings["J3NN"] = 0;
   f_settings["J4NN"] = 0;
   f_settings["J5NN"] = 0;
   f_settings["J6NN"] = 0;
   f_settings["JXNN"] = 0;
   f_settings["JANZ"] = 1;
   f_settings["J1NZ"] = 1;
   f_settings["J2NZ"] = 1;
   f_settings["J3NZ"] = 1;
   f_settings["J4NZ"] = 1;
   f_settings["J5NZ"] = 1;
   f_settings["J6NZ"] = 1;
   f_settings["JXNZ"] = 1;
   f_settings["JANP"] = 2;
   f_settings["J1NP"] = 2;
   f_settings["J2NP"] = 2;
   f_settings["J3NP"] = 2;
   f_settings["J4NP"] = 2;
   f_settings["J5NP"] = 2;
   f_settings["J6NP"] = 2;
   f_settings["JXNP"] = 2;
   f_settings["INCA"] = 0;
   f_settings["DECA"] = 1;
   f_settings["ENTA"] = 2;
   f_settings["ENNA"] = 3;
   f_settings["INC1"] = 0;
   f_settings["DEC1"] = 1;
   f_settings["ENT1"] = 2;
   f_settings["ENN1"] = 3;
   f_settings["INC2"] = 0;
   f_settings["DEC2"] = 1;
   f_settings["ENT2"] = 2;
   f_settings["ENN2"] = 3;
   f_settings["INC3"] = 0;
   f_settings["DEC3"] = 1;
   f_settings["ENT3"] = 2;
   f_settings["ENN3"] = 3;
   f_settings["INC4"] = 0;
   f_settings["DEC4"] = 1;
   f_settings["ENT4"] = 2;
   f_settings["ENN4"] = 3;
   f_settings["INC5"] = 0;
   f_settings["DEC5"] = 1;
   f_settings["ENT5"] = 2;
   f_settings["ENN5"] = 3;
   f_settings["INC6"] = 0;
   f_settings["DEC6"] = 1;
   f_settings["ENT6"] = 2;
   f_settings["ENN6"] = 3;
   f_settings["INCX"] = 0;
   f_settings["DECX"] = 1;
   f_settings["ENTX"] = 2;
   f_settings["ENNX"] = 3;
   f_settings["CMPA"] = 5;
   f_settings["CMP1"] = 5;
   f_settings["CMP2"] = 5;
   f_settings["CMP3"] = 5;
   f_settings["CMP4"] = 5;
   f_settings["CMP5"] = 5;
   f_settings["CMP6"] = 5;
   f_settings["CMPX"] = 5;
}
