///////////////////////////////////////////
//
// file:  MUL.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void MUL( )
{
   int           reg = 0;
   int           v = 0;

   long long int product = 0;

   MIX_word      V = GETV( );

   reg = (AREG.Byte_1( ) << 24)
         + (AREG.Byte_2( ) << 18)
         + (AREG.Byte_3( ) << 12)
         + (AREG.Byte_4( ) << 6)
         + AREG.Byte_5( );

   if( AREG.Byte_0( ) )
      reg = -reg;

   v = (V.Byte_1( ) << 24)
       + (V.Byte_2( ) << 18)
       + (V.Byte_3( ) << 12)
       + (V.Byte_4( ) << 6)
       + V.Byte_5( );

   if( V.Byte_0( ) )
      v = -v;

   product = reg * v;

   if( product < 0 )
   {
      AREG.Byte_0( 1 );
      XREG.Byte_0( 1 );
      product = -product;
   }
   else
   {
      AREG.Byte_0( 0 );
      XREG.Byte_0( 0 );
   }

   AREG.Byte_1( (product >> 54) & 0x3F );
   AREG.Byte_2( (product >> 48) & 0x3F );
   AREG.Byte_3( (product >> 42) & 0x3F );
   AREG.Byte_4( (product >> 36) & 0x3F );
   AREG.Byte_5( (product >> 30) & 0x3F );
   XREG.Byte_1( (product >> 24) & 0x3F );
   XREG.Byte_2( (product >> 18) & 0x3F );
   XREG.Byte_3( (product >> 12) & 0x3F );
   XREG.Byte_4( (product >> 6) & 0x3F );
   XREG.Byte_5( product & 0x3F );

   u_counter += 10;
}
