///////////////////////////////////////////
//
// file:  ST.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void ST( )
{
   int extracted_byte = 0;
   int f = INST.F( );
   int L = f >> 3;
   int m = INST.M( );
   int R = f & 7;
   int opcode = INST.C( );
   int source_register_byte = 5;

   while( R >= L )
   {
      switch( opcode )
      {
         case 24:
            if( source_register_byte == 5 )
               extracted_byte = AREG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = AREG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = AREG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = AREG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = AREG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = AREG.Byte_0( );

            break;

         case 25:
            if( source_register_byte == 5 )
               extracted_byte = I1REG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = I1REG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = I1REG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = I1REG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = I1REG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = I1REG.Byte_0( );

            break;

         case 26:
            if( source_register_byte == 5 )
               extracted_byte = I2REG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = I2REG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = I2REG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = I2REG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = I2REG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = I2REG.Byte_0( );

            break;

         case 27:
            if( source_register_byte == 5 )
               extracted_byte = I3REG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = I3REG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = I3REG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = I3REG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = I3REG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = I3REG.Byte_0( );

            break;

         case 28:
            if( source_register_byte == 5 )
               extracted_byte = I4REG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = I4REG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = I4REG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = I4REG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = I4REG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = I4REG.Byte_0( );

            break;

         case 29:
            if( source_register_byte == 5 )
               extracted_byte = I5REG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = I5REG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = I5REG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = I5REG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = I5REG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = I5REG.Byte_0( );

            break;

         case 30:
            if( source_register_byte == 5 )
               extracted_byte = I6REG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = I6REG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = I6REG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = I6REG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = I6REG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = I6REG.Byte_0( );

            break;

         case 31:
            if( source_register_byte == 5 )
               extracted_byte = XREG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = XREG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = XREG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = XREG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = XREG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = XREG.Byte_0( );

            break;

         case 32:
            if( source_register_byte == 5 )
               extracted_byte = JREG.Byte_5( );

            if( source_register_byte == 4 )
               extracted_byte = JREG.Byte_4( );

            if( source_register_byte == 3 )
               extracted_byte = JREG.Byte_3( );

            if( source_register_byte == 2 )
               extracted_byte = JREG.Byte_2( );

            if( source_register_byte == 1 )
               extracted_byte = JREG.Byte_1( );

            if( source_register_byte == 0 )
               extracted_byte = JREG.Byte_0( );

            break;

         case 33:
            extracted_byte = 0;
            break;

         default:
            break;
      }

      if( R == 5 )
      {
         if( m >= 0 )
            MEMORY[m].Byte_5( extracted_byte );
         else
            cs_MEMORY[-m].Byte_5( extracted_byte );
      }

      if( R == 4 )
      {
         if( m >= 0 )
            MEMORY[m].Byte_4( extracted_byte );
         else
            cs_MEMORY[-m].Byte_4( extracted_byte );
      }

      if( R == 3 )
      {
         if( m >= 0 )
            MEMORY[m].Byte_3( extracted_byte );
         else
            cs_MEMORY[-m].Byte_3( extracted_byte );
      }

      if( R == 2 )
      {
         if( m >= 0 )
            MEMORY[m].Byte_2( extracted_byte );
         else
            cs_MEMORY[-m].Byte_2( extracted_byte );
      }

      if( R == 1 )
      {
         if( m >= 0 )
            MEMORY[m].Byte_1( extracted_byte );
         else
            cs_MEMORY[-m].Byte_1( extracted_byte );
      }

      if( R == 0 )
      {
         if( m >= 0 )
            MEMORY[m].Byte_0( extracted_byte );
         else
            cs_MEMORY[-m].Byte_0( extracted_byte );
      }

      source_register_byte--;
      R--;
   }

   u_counter += 2;
}
