///////////////////////////////////////////
//
// file:  ascii_to_MIX.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


int ascii_to_MIX( int c )
{
   int retval = 0;

   switch( c )
   {
      case ' ':
         retval = 0;
         break;

      case 'A':
         retval = 1;
         break;

      case 'B':
         retval = 2;
         break;

      case 'C':
         retval = 3;
         break;

      case 'D':
         retval = 4;
         break;

      case 'E':
         retval = 5;
         break;

      case 'F':
         retval = 6;
         break;

      case 'G':
         retval = 7;
         break;

      case 'H':
         retval = 8;
         break;

      case 'I':
         retval = 9;
         break;

      case 'd':
         retval = 10;
         break;

      case 'J':
      case 'e':
         retval = 11;
         break;

      case 'K':
      case 'f':
         retval = 12;
         break;

      case 'L':
      case 'g':
         retval = 13;
         break;

      case 'M':
      case 'h':
         retval = 14;
         break;

      case 'N':
      case 'i':
         retval = 15;
         break;

      case 'O':
      case 'j':
         retval = 16;
         break;

      case 'P':
      case 'k':
         retval = 17;
         break;

      case 'Q':
      case 'l':
         retval = 18;
         break;

      case 'R':
      case 'm':
         retval = 19;
         break;

      case 'S':
         retval = 22;
         break;

      case 'T':
         retval = 23;
         break;

      case 'U':
         retval = 24;
         break;

      case 'V':
         retval = 25;
         break;

      case 'W':
         retval = 26;
         break;

      case 'X':
         retval = 27;
         break;

      case 'Y':
         retval = 28;
         break;

      case 'Z':
         retval = 29;
         break;

      case '0':
         retval = 30;
         break;

      case '1':
         retval = 31;
         break;

      case '2':
         retval = 32;
         break;

      case '3':
         retval = 33;
         break;

      case '4':
         retval = 34;
         break;

      case '5':
         retval = 35;
         break;

      case '6':
         retval = 36;
         break;

      case '7':
         retval = 37;
         break;

      case '8':
         retval = 38;
         break;

      case '9':
         retval = 39;
         break;

      case '.':
         retval = 40;
         break;

      case ',':
         retval = 41;
         break;

      case '(':
         retval = 42;
         break;

      case ')':
         retval = 43;
         break;

      case '+':
         retval = 44;
         break;

      case '-':
         retval = 45;
         break;

      case '*':
         retval = 46;
         break;

      case '/':
         retval = 47;
         break;

      case '=':
         retval = 48;
         break;

      case '$':
         retval = 49;
         break;

      case '<':
         retval = 50;
         break;

      case '>':
         retval = 51;
         break;

      case '@':
         retval = 52;
         break;

      case ';':
         retval = 53;
         break;

      case ':':
         retval = 54;
         break;

      case '\'':
         retval = 55;
         break;

      default:
         break;
   }

   return retval;
}
